<!DOCTYPE html>
<html>
    <head>
        <meta charset="UTF-8" />
        <title>{% block title %}Welcome!{% endblock %}</title>
        {% block stylesheets %}{% endblock %}
        <link rel="icon" type="image/x-icon" href="{{ asset('favicon.ico') }}" />
        <!-- mejor con esta -->
        <script src="//ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
    </head>
    <body>
        <div id="root"></div>
        <h2>
          js-notes-wrapper
        </h2>
        <div id="js-notes-wrapper"></div>
        <div id="my-grid"></div>

        <table id="my-table" border="1">
            <thead>
            <tr>
              <th scope="col">#</th>
              <th scope="col">Nombre de Equipo</th>
            </tr>
            </thead>
            <tbody>
          </tbody>
        </table>

        {% block body %}{% endblock %}
        <!--script src="{{ asset('build/app.js') }}"></script-->
        <!--  rep_log-->
        <!--
        -->
        {% block javascripts %}

<!--
        // const element = <h1>Hello, world</h1>;
        // const element = <NoteSection>Hello, world</NoteSection>;
        /*ReactDOM.render(
            element,
            document.getElementById('js-notes-wrapper')
        );*/

<script type="application/javascript" src='https://cdnjs.cloudflare.com/ajax/libs/react/0.13.3/react.js'></script>
<script type="application/javascript" src='https://cdnjs.cloudflare.com/ajax/libs/babel-core/5.8.23/browser.min.js'></script>
        
-->

        <script src="https://cdnjs.cloudflare.com/ajax/libs/react/0.14.3/react.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/react/0.14.3/react-dom.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/babel-core/5.8.23/browser.min.js"></script>

        <script src="{{ asset('build/app.js') }}"></script>
       
        <script type="text/babel" src="{{ asset('build/notes.react.js') }}"></script>
        
        <script type="text/babel" src="{{ asset('build/Customers.js') }}"></script>

        <script type="text/babel">
        /*class HelloMessage extends React.Component {
          render() {
            return (
              <div>
                Hello {this.props.name}
              </div>
            );
          }
        }

        ReactDOM.render(
          <HelloMessage name="Taylor" />,
          document.getElementById('js-notes-wrapper')
        );
*/

class Mi_NoteSection extends React.Component {
  constructor(props) {
    console.log('constructor Mi_NoteSection: ');

    super(props);
    this.state = { "seconds": 0, "notes": [], "clubs": [], "render":"", "equipo_id":0 };
    // this.notes = {};
    this.notes = [];
    this.cargado = false;
    this.otras_notas = {};

    // This binding is necessary to make `this` work in the callback
    this.handleClick = this.handleClick.bind(this);

  }

  handleClick(e, compName, id){
    console.log('compName: '+ compName);
    console.log('con id: '+ id);
    console.log('con key: '+ compName.key);
    console.log('con state.equipo_id: '+ this.state.equipo_id);
    // this.setState(render:compName);
    // this.setState(equipo_id:id);

    // compName = ''
    this.setState(state => ({
      render:compName,
      equipo_id:id
    }));

  }

  _renderSubComp(){
     console.log('renderizamos ' + this.state.equipo_id);
      switch(this.state.render){
          case 'listaJugadores': return <ListadoJugadores idequipo={this.state.equipo_id}/>

          // new
          default: return;
      }
  }

  tick() {
    this.setState(state => ({
      seconds: state.seconds + 1
    }));
  }

  componentDidMount() {
  var url = "http://localhost:8084/app_dev.php/api";
  fetch(url)
    .then(response => {
      return response.json();
    })
    .then(d => {
      this.setState({ clubs: d.clubs });
      console.log("state", this.state.clubs)
    })
    .catch(error => console.log(error))
  }

  render() {
    //{"response":"success","clubs":"[{\u0022id\u0022:1,\u0022nombre\u0022:\u0022ATLETICO DE MADRID\u0022},{\u0022id\u0022:2,\u0022nombre\u0022:\u0022REAL MADRID\u0022}]"}

    console.log('render this.state.clubs: ' + this.state.clubs);
    var mis_clubs = this.state.clubs;
    if (mis_clubs!=null && mis_clubs!='') {
      console.log('entramos ');
      console.log('typeof ' + typeof mis_clubs);
      console.log('mis_clubs ' + mis_clubs);

      mis_clubs = JSON.parse(mis_clubs);

/*
<div>
              {this._renderSubComp()}
            </div>

            onClick={this.handleClick.bind(this, 'listaJugadores', equipo.id)}

, this.state.equipo_id.bind(this, equipo.id)
*/
      return (
        <div>
          {
            mis_clubs.map(((equipo, index) =>
                    <div key={equipo.id}>
                        {equipo.id} - {equipo.nombre} {this.state.isToggleOn ? 'ON' : 'OFF'}
                      <button key={equipo.id} onClick={() => this.handleClick(this, 'listaJugadores', equipo.id)}>
                        {this.state.isToggleOn ? 'ON' : 'OFF'}
                      </button>
                    </div>
            ))
          }
          {this._renderSubComp()}
        </div>
      );
    } else {
      return (
      <div>Cargando Equipos</div>
      );
    }

   
  }
          
}

class ListadoJugadores extends React.Component {
  constructor(props) {
    super(props);

    this.state = { "jugadores": [], "idequipo": 0 };

    /*this.setState((state) => {
        // Important: read `state` instead of `this.state` when updating.
        return { "jugadores": [] }
    });*/

    /*if (this.props.idequipo!=this.state.equipo_id)
    {
      this.getListadoJugadores();
    }*/

  }

  getDerivedStateFromProps(props, state) {
    console.log('getDerivedStateFromProps');
    if (this.props.idequipo!=null && props.idequipo != this.props.idequipo) {
      return this.getListadoJugadores();
    }
  }

  getSnapshotBeforeUpdate(prevProps, prevState) {
    console.log('getSnapshotBeforeUpdate');
    // Are we adding new items to the list?
    // Capture the scroll position so we can adjust scroll later.
    /*if (prevProps.list.length < this.props.list.length) {
      const list = this.listRef.current;
      return list.scrollHeight - list.scrollTop;
    }
    return null;*/
    if (this.props.idequipo!=null && prevProps.props.idequipo != this.props.idequipo) {
      return this.getListadoJugadores();
    }
    return null;

  }

  componentDidUpdate(prevProps, prevState, snapshot) {
    console.log('componentDidUpdate');
    console.log('componentDidUpdate' + this.state.idequipo);
    // If we have a snapshot value, we've just added new items.
    // Adjust scroll so these new items don't push the old ones out of view.
    // (snapshot here is the value returned from getSnapshotBeforeUpdate)

    // console.log('prevProps ' + JSON.parse(prevProps));
    

    /*if (this.props.idequipo!='undefined' && prevProps.props.idequipo!='undefined') {
      if (prevProps.props.idequipo != this.props.idequipo) {
        this.getListadoJugadores();
      } 
    }*/
    if (this.state.idequipo != this.props.idequipo) {
        this.getListadoJugadores();
      }

  }

  getListadoJugadores() {
    var equipo = this.props.idequipo;

    this.setState(
      (state) => {
        // Important: read `state` instead of `this.state` when updating.
        return { "idequipo": equipo }
      }
      );
    var url = "http://localhost:8084/app_dev.php/apiListadoJugadores/" + equipo;
    console.log('Recibiendo listado para equipo ' + equipo);
    fetch(url)
      .then(response => {
        console.log('Recibiendo listado para equipo ' + equipo);
      return response.json();
    })
    .then(d => {
      this.setState({ jugadores: d.jugadores });
      console.log("state", this.state.jugadores)
    })
    .catch(error => console.log(error))
    
  }

  componentDidMount() {
    console.log('componentDidMount');
    // var url = "http://localhost:8084/app_dev.php/apiListadoJugadores/" + this.props.idequipo;
    // var equipo = this.state.equipo_id;
    this.getListadoJugadores();
  }

  render() {
    var mis_jugadores = this.state.jugadores;
    if (mis_jugadores!=null && mis_jugadores!='') {
      mis_jugadores = JSON.parse(mis_jugadores);

      return (
        <div>
          <div>Jugadores del {this.props.idequipo}</div>
          {
            mis_jugadores.map(((jugador, index) =>
                    <div key={jugador.id}>
                        {jugador.id_equipo} - {jugador.nombre}
                    </div>
            ))
          }
        </div>
      );

    } else {

      return (
        <div>Cargando Jugadores</div>
      );

    }

  }

  
}



        ReactDOM.render(
          <Mi_NoteSection name="Javi"  />,
          document.getElementById('js-notes-wrapper')
        );


        </script>

        {% endblock %}

        {% block javascripts_footer %}
            <script src="{{ asset('build/jquery.min.js') }}"></script>           
        {% endblock %}

        
    </body>
</html>
